<?php

	/*********************************
		checkform v.1.1b	
	**********************************
	
	
	
	2011 (c) By Christian Stankowic
	http://www.stankowic-development.net
	webmaster@stankowic-development.net
	*/
	
	
	
	//Version definieren
	define('CF_VERSION', '1.1b');
	
	
	
	class checkform
	/* Klasse zur Validation von Formulareingaben */
	{
	
		//Variablendeklarationen
		
			//Einstellungsparameter
			var $input_errorColor = "#ff9999";                        										//Hintergrundfarbe fuer Hervorhebungen von nicht oder falsch ausgefuellten Feldern
			var $input_successColor = "#ffffff";													//Hintergrundfarbe fuer Hervorhebungen von richtig ausgefuellten Feldern
			var $errorMsg = "Sie haben vergessen alle ben&ouml;tigten Felder (korrekt) auszuf&uuml;llen:";	//Fehlermeldung
			var $displayMsg = true;															//Soll eine Fehlermeldung angezeigt werden?
			var $displayList = true;															//Sollen die Felder als Liste angezeigt werden?
			var $shakeForm = true;															//Soll das Formular bei Fehleingaben wackeln?
			var $debugMode = false;															//Debug-Modus im JS aktivieren?
			
			//Regulaere Ausdruecke
			var $regexp = array(
				"text" => '/^[^\d][\D]{2,}$/',
				"webp" => '/^http:\/\/[\D]{2,}\.[\D]{2,4}$/',
				"mail" => '/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/',
				"post" => '/[0-9]{5}/',
				"tele" => '/^[0\+]{1}[\d]{2,}[\/\-]?[\d]+[\-]?[\d]+$/',
				"name" => '/^[^\d][\D]{2,} [^\d][\D]{2,}$/',
				/*"sele" => '[^\b]',
				"TAN" => '[^\b]',
				"chec" => '^((?!on).)*^',*/
				"hage" => '/^[1-9]{1}[0-9]{0,2}$/',
				"city" => '/^[^0-9][\D]{4,}$/',
				"numb" => '/^[0-9]{1,}$/'
			);
			
			//Blacklisten
			var $blacklists = array(
				"name" => array("Max Mustermann", "Don Huso"),
				"mail" => array("@owlpic.", "@10minutemail.", "@bofthew.", "@lhsdv.", "@prtnx.", "@pjjkp.com"),
				"webp" => array("porn.", "hackmenot."),
				"city" => array("Musterstadt", "Exampletown", "Beispiel", "bla", "test", "Test")
			);
		
		
		
		function debugMsg($msg)
		/* Debug-Nachricht ausgeben */
		{
		
			//Debug-Nachricht ausgeben, wenn erlaubt
			if($this->debugMode == true)
			{
				echo $msg;
			}
		
		}
		
		
		
		function loadBlacklist($target_blacklist, $filename)
		/* Blacklist aus Datei laden */
		{
		
			//Datei laden, wenn Array und Datei vorhanden
			if(is_array($this->blacklists[$target_blacklist]) && is_file($filename))
			{
			
				//Datei laden und an Array uebergeben
				$array=file($filename);
				$array = str_replace("\n", "", $array);
				$this->blacklists[$target_blacklist] = array_merge($this->blacklists[$target_blacklist], $array);
			
			}
		
		}
		
		
		
		function listBlacklists()
		/* Blacklisten inklusive Eintrage auflisten */
		{
			echo "<pre>";
			print_r($this->blacklists);
			echo "</pre><br />";
		}
		
		
		
		function addRegexp($new_name, $new_regexp)
		/* Einen regulaeren Ausdruck hinzufuegen */
		{
			//Ist der Key 4 Zeichen lang und wurde ein regulaerer Ausdruck angegeben?
			if(strlen($new_name) == 4 && $new_regexp != "")
			{
				//Ja, alle Angaben sind korrekt --> fuege Ausdruck hinzu
				$temp = array("$new_name" => "$new_regexp");
				$this->regexp=array_merge((array)$this->regexp, (array)$temp);
				return 0;
			}
		}
		
		
		
		function addBlacklist($new_blacklist)
		/* Eine eigene Blacklist hinzufuegen */
		{
		
			//Blacklist hinzufuegen, falls vierstellig
			if(strlen($new_blacklist) == 4)
			{
				//Eintrag zu blacklists-Array hinzufuegen
				$this->blacklists[$new_blacklist] = array();
			}
		
		}
		
		
		
		function addToBlacklist($target_blacklist, $new_entry)
		/* Einen Eintrag zu einer bestimmten Blacklist hinzufuegen */
		{
			
			//Wurden alle benoetigten Felder ausgefuellt?
			if($target_blacklist != "" && $new_entry != "")
			{
				//Ja, ist die Zielblackliste vorhanden?
				if(isset($this->blacklists["$target_blacklist"]) && is_array($this->blacklists["$target_blacklist"]))
				{
					//Ja, fuege Eintrag hinzu
					$this->debugMsg("$target_blacklist in blacklists<br />");
					array_push($this->blacklists[$target_blacklist], $new_entry);
					return true;
				}
				else
				{
					//Nein
					$this->debugMsg("$target_blacklist not in blacklists<br />");
					return false;
				}
			}
			else
			{
				//Nein
				return false;
			}
		}
		
		function renderJS()
		/* Das JavaScript rendern */
		{
			//JS rendern
			?>
			
					/*
						checkform v<?php echo CF_VERSION; ?>
						-----------------
						Skript zur Validierung von Formulareingaben
						
						
						
						2010 (c) By Christian Stankowic
						http://www.stankowic-development.net
						webmaster@stankowic-development.net
					*/



					//Globale Variablen
					var input_errorColor = "<?php echo $this->input_errorColor; ?>";
					var input_successColor = "<?php echo $this->input_successColor; ?>";
					<?php
					
						//Blacklisten definieren
						foreach($this->blacklists as $key => $value)
						{
							echo 'var blacklist_'.$key.' = Array(';
							//foreach($this->blacklists["$key"] as $entry)
							for($i=0;$i<sizeof($this->blacklists["$key"]);$i++)
							{
								if(($i+1) == sizeof($this->blacklists["$key"]))
								{
									//letzter Eintrag
									echo "\"".$this->blacklists["$key"][$i]."\"";
								}
								else
								{
									echo "\"".$this->blacklists["$key"][$i]."\", ";
								}
							}
							echo ');'."\n";
						}
					
					?>
					var errorMsg = "<?php echo $this->errorMsg ?>";
					var displayMsg = <?php if($this->displayMsg == true) { echo "true;\n"; } else { echo "false;\n"; } ?>;
					var displayList = <?php if($this->displayList == true) { echo "true;\n"; } else { echo "false;\n"; } ?>;
					var shakeForm = <?php if($this->shakeForm == true) { echo "true;\n"; } else { echo "false;\n"; } ?>;

					/*--------------------------------------------------*/
					var errorFields = "";
					var errorFlag = 0;
					<?php
						if($this->debugMode == true)
						{
							echo 'var debugMode = true;';
						}
						else
						{
							echo 'var debugMode = false;';
						}
					?>



					function validate_field(formname, field_name, regexp)
					/* Feld validieren */
					{
					
						//Debug-Ausgaben
						debugMsg("checking field " + field_name);
						debugMsg("Check: " + regexp + " on " + eval("document.forms." + formname + "." + field_name + ".name"));
						
						//Match der regulaere Ausdruck?
						if(regexp.test(eval("document.forms." + formname + "." + field_name + ".value")) == true)
						{
						
							//Debug
							debugMsg("Regexp matches on " + eval("document.forms." + formname + "." + field_name + ".name"));
							
							//Ja --> gleiche, falls gewuenscht, mit Blacklist ab
							if(validate_field.arguments.length == 4)
							{
							
								for(var i=0;i<eval(validate_field.arguments[3].length);i++)
								{
									//Diagnose-Ausgabe --> testing
									debugMsg(eval("document.forms." + formname + "." + field_name + ".value") + " in " + eval(validate_field.arguments[3])[i] + " = " + eval("document.forms." + formname + "." + field_name + ".value").indexOf(eval(validate_field.arguments[3])[i]));
									
									if(eval("document.forms." + formname + "." + field_name + ".value").indexOf(eval(validate_field.arguments[3])[i]) > -1)
									{
										//Ja, sie ist in der Blacklist vorhanden --> markiere als "fehlerhaft" und breche ab
										setInvalid(formname, field_name);
										errorFlag = 1;
										errorFields = errorFields + " " + "\n" + eval("document.forms." + formname + "." + feld[i] + ".name").substring(5, eval("document.forms." + formname + "." + feld[i] + ".name").length);
										return false;
										//break;
									}
								}

								//Markiere als "korrekt"
								setValid(formname, field_name);
								return true;
								
							}
							else
							{
								//Markiere als "korrekt"
								setValid(formname, field_name);
								return true;
							}
						}
						else
						{
							//Nein --> markiere als "fehlerhaft"
							debugMsg("Regexp DONT MATCH on " + eval("document.forms." + formname + "." + field_name + ".name"));
							setInvalid(formname, field_name);
							errorFlag = 1;
							errorFields = errorFields + " " + "\n" + eval("document.forms." + formname + "." + field_name + ".name").substring(5, eval("document.forms." + formname + "." + field_name + ".name").length);
						}
					}
					
					
					
					function convertHTMLTags(message_text)
					//Sonderzeichen durch HTML-Tags ersetzen
					{
						//Arrays definieren
						var umlauts 		= Array("", "", "", "", "", "", "");
						var htmlentities	= Array("&ouml;", "&Ouml;", "&uuml;", "&Uuml;", "&auml;", "&Auml;", "&szlig;");
						
						//Einzelne Buchstaben ersetzen
						for(var i=0; i<umlauts.length; i++)
						{
							//Ausgabe des ersetzten Zeichens --> testing
							debugMsg(umlauts[i] + " --> " + htmlentities[i]);
							
							//Zeichen im Text ersetzen
							message_text = message_text.replace(umlauts[i], htmlentities[i]);
						}
						
						//Text wieder uebergeben
						return message_text;
					}



					function errorMessage(title, fields)
					/* Fehlermeldung ausgeben */
					{

						//Umbrueche ersetzen und Text ausgeben
						var message = "";
						if(displayList == true)
						{
							//Als Liste anzeigen
							var temp = fields.split("\n");
							for(var i=1;i<temp.length;i++)
							{
								message = message + "<li>" + temp[i] + "</li>";
							}
							
							message = title + "<ul>" + message + "</ul>";
							eval("document.getElementById('error').innerHTML=\"" + convertHTMLTags(message) + "\";");
							//eval("document.getElementById('error').innerHTML=\"" + message + "\";");
						}
						else
						{
							//Als Text anzeigen
							fields = fields.replace(/\r\n|\n/g, "<br />");
							message = title + fields;
							eval("document.getElementById('error').innerHTML=\"" + convertHTMLTags(message) + "\";");
							//eval("document.getElementById('error').innerHTML=\"" + message + "\";");
						}
					}



					function setInvalid(formname, field)
					/* Ein Eingabefeld als fehlerhaft markieren */
					{
						debugMsg("Marking " + eval("document.forms." + formname + ".elements." + field + ".name") + " as invalid.");
						eval("document.forms." + formname + ".elements." + field + ".style.backgroundColor='" + input_errorColor + "'");
					}



					function setValid(formname, field)
					/* Ein Eingabefeld als korrekt markieren */
					{
						debugMsg("Marking " + eval("document.forms." + formname + ".elements." + field + ".name") + " as valid.");
						eval("document.forms." + formname + ".elements." + field + ".style.backgroundColor='" + input_successColor + "'");	
					}
					
					
					
					function debugMsg(msg)
					/* Debug-Nachricht ausgeben, wenn erwuenscht */
					{
						
						if(debugMode == true)
						{
							alert(msg);
						}
						
					}
					
					
					
					function checkElements(formname)
					/* Die Elemente eines Formulars auf Inhalt ueberpruefen */
					{
						
						//Ausgabe des zu ueberpruefenden Formulars und der Anzahl der Felder --> testing
						//debugMsg("Formular " + formname + " ist zu ueberpruefen, es gibt " + (arguments.length-1) + " zu ueberpruefende Felder.");
						
						//Speichern der Parameter  in einem Array
						feld = new Array();
						errorFields = "";
						errorFlag = 0;
						
						for(var i=0;i<arguments.length-1;i++)
						{
							feld[i] = arguments[i+1];
						}
						
						//Ausgabe der uebertragenen Feldnamen --> testing
						var debug_fields = "About to check the following " + feld.length + " fields:\n";
						for(var i=0;i<feld.length;i++)
						{
							debug_fields = debug_fields + feld[i] + "\n";
						}
						debugMsg(debug_fields);
						
						//Ueberpruefen der Felder
						for(var i=0;i<feld.length;i++)
						{
						
							//Ausgabe des Feldes --> testing
							//alert ("Inhalt des Feldes " + feld[i] + ": " + eval("document.forms." + formname + "." + feld[i] + ".value"));
						
							//Wurde das Feld ausgefuellt?
							switch(eval("document.forms." + formname + "." + feld[i] + ".name").substring(0,5))
							{
							
							<?php
							
								foreach($this->regexp as $key => $value)
								{
									//Einleitung Case
									echo 'case "'.$key.'_":'."\n";
									
									//Ist eine Blacklist vorhanden?
									if(isset($this->blacklists["$key"]) && is_array($this->blacklists["$key"]))
									{
										//Ja, uebergebe Sie
										echo 'validate_field(formname, feld[i], '.$value.', blacklist_'.$key.');'."\n";
									}
									else
									{
										//Nein
										echo 'validate_field(formname, feld[i], '.$value.');'."\n";
									}
									
									//Ende Case
									echo 'break;'."\n\n";
								}
							
							?>
							
								//case "text_":			
								//validate_field(formname, feld[i], /^[^\d][\D]{3,}$/);
								//break;

								//Webseite
								//case "webp_":
								//validate_field(formname, feld[i], /^http:\/\/[\D]{2,}\.[\D]{2,4}$/, blacklist_web);
								//break;
								
								//Checkbox
								case "chec_":
									if(eval("document.forms." + formname + "." + feld[i] + ".checked") == false)
									{
										errorFlag = 1;
										errorFields = errorFields + " " + "\n" + eval("document.forms." + formname + "." + feld[i] + ".name").substring(5, eval("document.forms." + formname + "." + feld[i] + ".name").length);
									}
									break;
								
								//Unbekanntes Feld
								default:
									if(eval("document.forms." + formname + "." + feld[i] + ".value") == "")
									{
										//Das Feld wurde nicht ausgefuellt --> setze das Flag und erweitere Liste mit vergessenen Feldern
										errorFlag = 1;
										errorFields = errorFields + " " + "\n" + eval("document.forms." + formname + "." + feld[i] + ".name");
										
										//Aendern der Hintergrundfarbe des Eingabefelds
										setInvalid(formname, feld[i]);
									}
									else
									{
										//Feld korrekt ausgefuellt, faerbe Feld (wieder) korrekt ein
										setValid(formname, feld[i]);
									}
									break;
								
							}
						
						}
						
						//Sind Fehler aufgetreten?
						if (errorFlag == 1)
						{
							//Es sind Fehler aufgetreten, gebe Fehlermeldung aus und wackele mit der Form, falls gewuenscht
							if(displayMsg == true) {errorMessage(errorMsg, errorFields); }
							if(shakeForm == true) { eval("new Effect.Shake('" + formname + "', {distance:20});") }
						}
						else
						{
							//Es wurden alle Felder ausgefuellt --> sende Daten an das Formular
							eval("document.forms."+ formname+ ".submit()");
						}

					} 
			
			<?php
		}
		
		function listRegexp()
		/* Die definierten regulaeren Ausdruecke anzeigen */
		{
			for($i=0;$i<sizeof($this->regexp);$i++)
			{
				echo "<b>REGEXP:</b> ".key($this->regexp)." ==> ".current($this->regexp)."<br />";
				next($this->regexp);
			}
		}
		
		
		
		function checkArray($target_array)
		/* Ein Array validieren */
		{
			//Array ueberpruefen
			
			//Alle uebertragenen Werte ausgeben --> testing
			/*for($i=0;$i<sizeof($target_array);$i++)
			{
				echo "<b>VALUE:</b> ".key($target_array)." ==> ".current($target_array)."<br />";
				next($target_array);
			}*/
			
			//Alle definierten regulaeren Ausdruecke ausgeben --> testing
			//$this->listRegexp();
			
			//Ausgeben der uebergegebenen Werte, dem passenden regulaeren Ausdruck und dem Ergebnis --> testing
			/*for($i=0;$i<sizeof($target_array);$i++)
			{
				echo "<b>PREG:</b> ".current($target_array)." ==> ".$this->regexp[substr(key($target_array), 0, 4)]." ==> <b>".preg_match($this->regexp[substr(key($target_array), 0, 4)], current($target_array))."</b><br />";
				next($target_array);
			}*/
			
			//Ueberpruefen der uebergegebenen Werte und uebergeben des Resultats
			$counter=0;
			for($i=0;$i<sizeof($target_array);$i++)
			{
				
				//Handelt es sich um eine Checkbox,ein Select- oder ein unbekanntes Feld?
				if(substr(key($target_array), 0, 5) == "sele_" || substr(key($target_array), 0, 5) == "chec_" || strpos(substr(key($target_array), 0, 5), "_") == false)
				{
					//Ist eine Eingabe vorhanden?
					if(current($target_array) == "")
					{
						//Nein, fehlerhafte Eingabe!
						$temp[$counter] = key($target_array);
						$counter++;
					}
				}
				//Alle nicht-optionalen Felder ueberpruefen
				elseif(substr(key($target_array), 0, 5) != "opti_")
				{
				
					//Passt der entsprechende regulaere Ausdruck auf die Eingabe?
					if(preg_match($this->regexp[substr(key($target_array), 0, 4)], current($target_array)) == 0)
					{
						//Nein, fehlerhafte Eingabe!
						$temp[$counter] = key($target_array);
						$counter++;
					}
					else
					{
						//Ja, korrekte Eingabe --> gibt es eine Blacklist fuer die Eingabe?
						if(isset($this->blacklists[substr(key($target_array), 0, 4)]) && is_array($this->blacklists[substr(key($target_array), 0, 4)]))
						{
							//Ja, es gibt eine Blacklist --> ist der Eintrag in der Blacklist vorhanden?
							$this->debugMsg("blacklist ".substr(key($target_array), 0, 4)." exists<br />");
							
							if(  in_array(current($target_array), $this->blacklists[substr(key($target_array), 0, 4)])  )
							{
								//Ja, ist er --> als fehlerhaft markieren
								//echo current($target_array)." found in blacklist ".substr(key($target_array), 0, 4)."<br />";
								$temp[$counter] = key($target_array);
								$counter++;
							}
							
						}
						else
						{
							//Nein, es gibt keine Blacklist
							$this->debugMsg("blacklist ".substr(key($target_array), 0, 4)." doesn't exist<br />");
						}
					}
					
				}
				else
				{
				}
				
				//Naechsten Eintrag
				next($target_array);
			}
			
			if(isset($temp) && sizeof($temp) > 0)
			{
				return $temp;
			}
			else
			{
				return true;
			}
			
		}
	
	}

?>